--- bytecomp.el.orig	2014-03-21 14:34:40.000000000 +0900
+++ bytecomp.el	2014-10-19 19:17:00.915199400 +0900
@@ -3329,15 +3329,24 @@
     (byte-compile-form (nth 2 form))
     (byte-compile-out (get (car form) 'byte-opcode) 0)))
 
+(defun byte-compile-all-copyable-p (list)
+  "Non-nil if all elements of LIST satisfy `macroexp-copyable-p."
+  (while (and list (macroexp-copyable-p (car list)))
+    (setq list (cdr list)))
+  (null list))
+
 (defun byte-compile-and-folded (form)
   "Compile calls to functions like `<='.
-These implicitly `and' together a bunch of two-arg bytecodes."
+These implicitly `and' together a bunch of two-arg bytecodes when
+non-first operands are side-effect free."
   (let ((l (length form)))
     (cond
      ((< l 3) (byte-compile-form `(progn ,(nth 1 form) t)))
      ((= l 3) (byte-compile-two-args form))
-     (t (byte-compile-form `(and (,(car form) ,(nth 1 form) ,(nth 2 form))
-				 (,(car form) ,@(nthcdr 2 form))))))))
+     ((byte-compile-all-copyable-p (nthcdr 2 form))
+      (byte-compile-form `(and (,(car form) ,(nth 1 form) ,(nth 2 form))
+			       (,(car form) ,@(nthcdr 2 form)))))
+     (t (byte-compile-normal-call form)))))
 
 (defun byte-compile-three-args (form)
   (if (not (= (length form) 4))
